<?php

/*

	Plugin Name: Fun Facts
	Plugin URI: http://www.joeswebtools.com/wordpress-plugins/fun-facts/
	Description: Adds a sidebar widget that display interesting, useless, weird and wonderful random fun facts. After activating the plugin, go to <a href="widgets.php">Appearance &rarr; Widgets</a> to install the widget and to <a href="options-general.php?page=fun-facts/fun-facts.php">Settings &rarr; Fun Facts</a> to add your own fun facts.
	Version: 1.0
	Author: Joe's Web Tools
	Author URI: http://www.joeswebtools.com/

	Copyright 2009 Philippe Paquet (email: philippe@paquet.net)

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
	
	If you are unable to comply with the terms of the GNU General Public License,
	contact the copyright holder for a commercial license.

*/



function widget_funfacts_display($args) {

	global $wpdb;

	// Get options
	$title = htmlspecialchars(get_option('widget_funfacts_title'), ENT_QUOTES);

	// Create the table name
	$table_name = $wpdb->prefix . 'fun_facts';
	
	// Get a fun fact
	$funfact_count = $wpdb->get_var("SELECT COUNT(*) FROM $table_name");
	$funfact_random = rand(0, $funfact_count - 1);
	$funfact_record = $wpdb->get_results("SELECT * FROM $table_name WHERE id={$funfact_random}");
	foreach($funfact_record as $funfacts_current) {
		$funfact_text = $funfacts_current->fun_fact;
	}
	// Help widget to conform to the active theme: before_widget, before_title and after_title
	extract($args);
	echo $before_widget . $before_title . $title . $after_title;

	// Display widget content
	echo '<div style="text-align: justify;">' . $funfact_text . '</div>';
	echo '<div style="text-align: right;"><font face="arial" size="-3"><a href="http://www.joeswebtools.com/wordpress-plugins/fun-facts/" title="Fun Facts widget plugin for WordPress">Joe\'s</a></font></div>';

	// Help widget to conform to the active theme: after_widget
	echo $after_widget;
}



function widget_funfacts_control() {

	// Load language file
	$current_locale = get_locale();
	if(!empty($current_locale)) {
		$mo_file = dirname(__FILE__) . '/languages/fun-facts-' . $current_locale . ".mo";
		if(@file_exists($mo_file) && is_readable($mo_file)) {
			load_textdomain('funfacts', $mo_file);
		}
	}

	// Update options if the form was posted
	if($_POST['widget-fun-facts-submit']) {

		// Title
		if(!empty($_POST['widget-fun-facts-title'])) {
			update_option('widget_funfacts_title', strip_tags(stripslashes($_POST['widget-fun-facts-title'])));
		} else {
			update_option('widget_funfacts_title', __('Fun Facts', 'funfacts'));
		}
	}

	// Title
	$title = htmlspecialchars(get_option('widget_funfacts_title'), ENT_QUOTES);

	// The form fields
	echo '<label for="widget-fun-facts-title">' . __('Title: ', 'funfacts') . '<br /><input type="text" class="widefat" id="widget-fun-facts-title" name="widget-fun-facts-title" value="' . $title . '" /></label><br />';
	echo '<br />';
	echo '<input type="hidden" id="widget-fun-facts-submit" name="widget-fun-facts-submit" value="1" />';
}



function widget_funfacts_page() {

	global $wpdb;

	// Load language file
	$current_locale = get_locale();
	if(!empty($current_locale)) {
		$mo_file = dirname(__FILE__) . '/languages/fun-facts-' . $current_locale . ".mo";
		if(@file_exists($mo_file) && is_readable($mo_file)) {
			load_textdomain('funfacts', $mo_file);
		}
	}

	// Create the table name
	$table_name = $wpdb->prefix . 'fun_facts';

	// Update data
	if(isset($_POST['update'])) {

		// Truncate table
		$results = $wpdb->query("TRUNCATE TABLE $table_name");

		// Update
		if($funfacts_list = strip_tags(stripslashes($_POST['funfactslist']))) {

			$funfacts_array = explode("\n", $funfacts_list);
			sort($funfacts_array);

			foreach($funfacts_array as $funfacts_current) {
				$funfacts_current = trim($funfacts_current);
				if(!empty($funfacts_current)) {
					if(NULL == $wpdb->get_var("SELECT fun_fact FROM $table_name WHERE fun_fact='" . $wpdb->escape($funfacts_current) . "'")) {
						$wpdb->query("INSERT INTO $table_name(fun_fact) VALUES('" . $wpdb->escape($funfacts_current) . "')");
					}
				}
			}
		}
	}

	// Restore defaults
	if(isset($_POST['default'])) {

		// Truncate table
		$results = $wpdb->query("TRUNCATE TABLE $table_name");

		// Get the fun facts
		$funfacts_array = file(dirname(__FILE__) . '/fun-facts.dat');
		sort($funfacts_array);

		// Import the fun facts
		foreach($funfacts_array as $funfacts_current) {
			$funfacts_current = trim($funfacts_current);
			if(!empty($funfacts_current)) {
				if(NULL == $wpdb->get_var("SELECT fun_fact FROM $table_name WHERE fun_fact='" . $wpdb->escape($funfacts_current) . "'")) {
					$wpdb->query("INSERT INTO $table_name(fun_fact) VALUES('" . $wpdb->escape($funfacts_current) . "')");
				}
			}
		}
	}

	// Page wrapper start
	echo '<div class="wrap">';

	// Title
	screen_icon();
	echo '<h2>Fun Facts</h2>';

	// Options
	echo	'<div id="poststuff" class="ui-sortable">';
	echo		'<div class="postbox opened">';
	echo			'<h3>' . __('Options', 'funfacts') . '</h3>';
	echo			'<div class="inside">';
	echo				'<form method="post">';
	echo					'<table class="form-table">';
	echo						'<tr>';
	echo							'<th scope="row" valign="top">';
	echo								'<b>' . __('Fun Facts List', 'funfacts') . '</b>';
	echo							'</th>';
	echo							'<td>';
	echo								'<textarea name="funfactslist" rows="15" cols="80" wrap="off" style="overflow: auto;">';
											$record = $wpdb->get_results("SELECT * FROM $table_name");
											foreach($record as $record) {
												echo $record->fun_fact . "\r\n";
											}
	echo								'</textarea><br />';
	echo								__('Only one fun fact per line, not html code.', 'fun-facts');
	echo							'</td>';
	echo						'</tr>';
	echo						'<tr>';
	echo							'<td colspan="2">';
	echo								'<input type="submit" class="button-primary"  name="update" value="' . __('Save Changes', 'funfacts') . '" />';
	echo								'&nbsp;&nbsp;&nbsp;';	
	echo								'<input type="submit" class="button-primary"  name="default" value="' . __('Restore defaults', 'funfacts') . '" />';
	echo							'</td>';
	echo						'</tr>';
	echo					'</table>';
	echo				'</form>';
	echo			'</div>';
	echo		'</div>';
	echo	'</div>';

	// About
	echo	'<div id="poststuff" class="ui-sortable">';
	echo		'<div class="postbox opened">';
	echo			'<h3>' . __('About', 'funfacts') . '</h3>';
	echo			'<div class="inside">';
	echo				'<form method="post">';
	echo					'<table  class="form-table">';
	echo						'<tr>';
	echo							'<th scope="row" valign="top">';
	echo								'<b>' . __('Like this plugin?', 'funfacts') . '</b>';
	echo							'</th>';
	echo							'<td>';
	echo								__('Developing, maintaining and supporting this plugin requires time. Why not do any of the following:', 'funfacts') . '<br />';
	echo								'&nbsp;&bull;&nbsp;&nbsp;' . __('Check out our <a href="http://www.joeswebtools.com/wordpress-plugins/">other plugins</a>.', 'funfacts') . '<br />';
	echo								'&nbsp;&bull;&nbsp;&nbsp;' . __('Link to the <a href="http://www.joeswebtools.com/wordpress-plugins/fun-facts/">plugin homepage</a>, so other folks can find out about it.', 'funfacts') . '<br />';
	echo								'&nbsp;&bull;&nbsp;&nbsp;' . __('Give this plugin a good rating on <a href="http://wordpress.org/extend/plugins/fun-facts/">WordPress.org</a>.', 'funfacts') . '<br />';
	echo								'&nbsp;&bull;&nbsp;&nbsp;' . __('Support further development with a <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=5162912">donation</a>.', 'funfacts') . '<br />';
	echo							'</td>';
	echo						'</tr>';
	echo						'<tr>';
	echo							'<th scope="row" valign="top">';
	echo								'<b>' . __('Need support?', 'fun-facts') . '</b>';
	echo							'</th>';
	echo							'<td>';
	echo									__('If you have any problems or good ideas, please talk about them on the <a href="http://www.joeswebtools.com/wordpress-plugins/fun-facts/">plugin homepage</a>.', 'funfacts') . '<br />';
	echo							'</td>';
	echo						'</tr>';
	echo						'<tr>';
	echo							'<th scope="row" valign="top">';
	echo								'<b>' . __('Credits', 'funfacts') . '</b>';
	echo							'</th>';
	echo							'<td>';
	echo									__('<a href="http://www.joeswebtools.com/wordpress-plugins/fun-facts/">Fun Facts</a> is developped by Philippe Paquet for <a href="http://www.joeswebtools.com/">Joe\'s Web Tools</a>. This plugin is released under the GNU General Public License version 2. If you are unable to comply with the terms of the GNU General Public License, contact the copyright holder for a commercial license.', 'funfacts') . '<br />';
	echo							'</td>';
	echo						'</tr>';
	echo					'</table>';
	echo				'</form>';
	echo			'</div>';
	echo		'</div>';
	echo	'</div>';

	// Page wrapper end
	echo '</div>';

}



function widget_funfacts_add_menu() {

	// Add the menu page
	add_submenu_page('options-general.php', 'Fun Facts', 'Fun Facts', 10, __FILE__, 'widget_funfacts_page');
}



function widget_funfacts_init() {

	if(function_exists('register_sidebar_widget')) {
		register_sidebar_widget('Fun Facts', 'widget_funfacts_display');
	}

	if(function_exists('register_widget_control')) {
		register_widget_control(array('Fun Facts', 'widgets'), 'widget_funfacts_control');
	}
}



function widget_funfacts_activate() {

	global $wpdb;

	// Load language file
	$current_locale = get_locale();
	if(!empty($current_locale)) {
		$mo_file = dirname(__FILE__) . '/languages/fun-facts-' . $current_locale . ".mo";
		if(@file_exists($mo_file) && is_readable($mo_file)) {
			load_textdomain('funfacts', $mo_file);
		}
	}

	// Create the table name
	$table_name = $wpdb->prefix . 'fun_facts';

	// Create the table if it doesn't already exist
	$results = $wpdb->query("CREATE TABLE IF NOT EXISTS $table_name(id INT(11) NOT NULL AUTO_INCREMENT, fun_fact VARCHAR(2048) DEFAULT NULL, PRIMARY KEY (id), KEY fun_fact (fun_fact));");

	// Get the fun facts
	$funfacts_array = file(dirname(__FILE__) . '/fun-facts.dat');
	sort($funfacts_array);

	// Import the fun facts
	foreach($funfacts_array as $funfacts_current) {
		$funfacts_current = trim($funfacts_current);
		if(!empty($funfacts_current)) {
			if(NULL == $wpdb->get_var("SELECT fun_fact FROM $table_name WHERE fun_fact='" . $wpdb->escape($funfacts_current) . "'")) {
				$wpdb->query("INSERT INTO $table_name(fun_fact) VALUES('" . $wpdb->escape($funfacts_current) . "')");
			}
		}
	}

	// Set default title if necessary
	$title = htmlspecialchars(get_option('widget_funfacts_title'), ENT_QUOTES);
	if(empty($title)) {
		update_option('widget_funfacts_title', __('Fun Facts', 'funfacts'));
	}
}



add_action('plugins_loaded', 'widget_funfacts_init');
add_action('admin_menu', 'widget_funfacts_add_menu');
register_activation_hook(__FILE__, 'widget_funfacts_activate');

?>